import React,{Component} from "react";
import {AtCalendar, AtModal, AtModalAction, AtModalContent} from "taro-ui";
import {Button} from "@tarojs/components";
import Enterprise from './enterprise';
import PublicContent from './publicContent';

import {updatePublicRelease} from '../../utils/servers/servers';

import 'taro-ui/dist/style/components/modal.scss';
import Taro from "@tarojs/taro";

class Modify extends Component{
  constructor(props) {
    super(props);
    this.state={
      data:{},
      dtails:props.dtails,
      modifyType:1,
    }
    this.submit = this.submit.bind(this);
    this.onChange = this.onChange.bind(this);
  }

  submit(){
    if(Object.keys(this.state.data).length === 0){
      Taro.showToast({title:'请先选择公出的企业',icon:'none'})
      return;
    }
    this.setState({
      modifyType:2
    })
  }

  componentWillUnmount() {
    this.setState({
      data:{}
    })
  }

  onChange(value){
    this.setState({
      dtails:{
        ...this.state.dtails,
        ...value,
      },
      data:value,
    })
  }

  render() {
    return (
      <AtModal isOpened={this.props.isOpened} onClose={this.props.onModalClose}>
        <AtModalContent>
          {
            this.state.modifyType === 1 ?
              <Enterprise isOpened={this.props.isOpened} onChange={this.onChange}/> :
              <PublicContent
                permission={this.props.permission}
                index={this.props.index}
                onClose={()=>{
                  this.props.onClose();
                }}
                locationInfor={this.props.locationInfor}
                dtails={this.state.dtails}
                isOpened={this.props.isOpened}
                onChange={this.onChange}
              />
          }
        </AtModalContent>
        {
          this.state.modifyType === 1 ?
            <AtModalAction>
              <Button onClick={()=>{
                this.props.onClose();
              }}>
                取消
              </Button>
              <Button onClick={this.submit}>
                下一步
              </Button>
            </AtModalAction>:
            null
        }
      </AtModal>
    )
  }
}

export default Modify;
